import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class PanelDemo extends Applet {
  private Panel buttonPanel, imagePanel;

  private Button buttons[];
  private Choice choice;


  private ScrollPane sp;

  private int imgWidth, imgHeight;
  
  public void init() {
    Panel tempPanel = new Panel();
    Button tempButton = new Button("temp");

    tempPanel.setLayout(new GridLayout(1,1));
    tempPanel.add(tempButton);
  
    buttonPanel = new Panel();
    buttons = new Button [1];
    
    choice = new Choice();

    choice.add("Linden");
    choice.add("Birth");

    buttonPanel.setLayout(new GridLayout(1,2));

    buttonPanel.add(choice);
    
    for (int i=0; i<buttons.length; i++) {
      buttons[i]= new Button("Button"+(i+1));
      buttonPanel.add(buttons[i]);
    }
    
    imagePanel = new Panel();
    imagePanel.setLayout(new GridLayout(1,1));

    //sp = new ScrollPane(ScrollPane.SCROLLBARS_ALWAYS);
    sp = new ScrollPane();

    Image img = getImage( getCodeBase(), "picture.gif" ) ;

    ICanvas canvas = new ICanvas(img);

    //    sp.setSize(img.getSize().width, img.getSize().height);    
    while ((imgHeight = img.getHeight(this)) == -1 ) {
      // loop until image loaded
    }
    while ((imgWidth = img.getWidth(this)) == -1 ) {
      // loop until image loaded
    }

    canvas.setSize(imgWidth, imgHeight);

    sp.add(canvas);

    
    imagePanel.add(sp);



    //GridBagLayout gridbag = new GridBagLayout();

    //setLayout( gridbag ) ;
    setLayout(new BorderLayout());

    add("Center",imagePanel);
    add("South",buttonPanel);

    /*
    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.BOTH ;
      c.gridx=0;
      c.gridy=0;
      c.gridwidth=1;
      c.gridheight=1;
      add( imagePanel ) ;
    }

    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.HORIZONTAL ;

      c.gridx=1;
      c.gridy=0;
      c.gridwidth=1;
      c.gridheight=1;
      add( buttonPanel ) ;
    }
    */

  }
   
}  
  
class ICanvas extends Canvas {
  private Image image; 
  
  public ICanvas(Image image) {
    this.image=image;
  }

  
  public void paint(Graphics g) {
    g.drawImage(image, 1, 1, this);
  }
}
